signature INTERPRETATION =
  sig
    datatype person = a | b | c | d | e | f | g | h | i | j | k 
                    | l | m | n | p | q | r | s | t | u | v | w 

    type PN
    type NP
    type S = bool
    type N
    type DET
    type COP
    type TV
    type IV
    type CONJ1
    type CONJ2

    val Maria : PN
    val Emil : PN
    val Anna : PN
    val Frau : N
    val Mann : N
    val Student : N
    val arbeitet : IV
    val kennt : TV
    val liebt : TV

    val ist : COP
    val der : DET
    val die : DET

    val nicht : CONJ1
    val und : CONJ2
    val oder : CONJ2

    val toString : person -> string
  end

structure D : INTERPRETATION =
  struct
    (* Wertebereiche der syntaktischen Kategorien: *)

    datatype person = a | b | c | d | e | f | g | h | i | j | k 
                    | l | m | n | p | q | r | s | t | u | v | w 

    type PN = person
    type NP = person
    type S = bool
    type N = person -> bool
    type DET = (person -> bool) -> person
    type COP = person * person -> bool
    type IV = (person -> bool) 
    type TV = (person * person -> bool)
    type CONJ1 = (bool -> bool)
    type CONJ2 = (bool * bool -> bool)

    (* Werte der einfachen Ausdruecke: *)

    val Anna = a
    val Emil = e
    val Maria = m

    fun nicht(x) = not x
    fun und(x,y) = x andalso y
    fun oder(x,y) = x orelse y

    fun Frau( a | b | c | g | h | i | m | n | s | t | u ) = true 
      | Frau(_) = false

    fun Mann( d | e | f | j | k | l | p | q | r | v | w ) = true 
      | Mann(_) = false

    fun Student( u | v | w ) = false
      | Student(_) = true

    fun arbeitet( a | b | c | d | e ) = true
      | arbeitet(_) = false
    
    fun kennt( (a,e) | (a,m) | (e,a) | (m,e) ) = true
      | kennt(x,y) = if x=y then true else false

    fun liebt( (e,m) | (a,e) ) = true
      | liebt(_) = false
    
    fun der(F) = case (List.find F [a,b,c,d,e,f,g,h,i,j,k,
                                    l,m,n,p,q,r,s,t,u,v,w])
                  of SOME x => x | NONE => a
    fun die(F) = der(F)

    fun ist(x,y) = if x=y then true else false

    val toString = (fn a => "a" | b => "b" | c => "c" 
                     | d => "d" | e => "e" | m => "m"
                       | _ => "some person")
  end

